"""
Django settings for choucas project.

Generated by 'django-admin startproject' using Django 1.11.dev20160619004538.
This application runs on Django 1.8 and 1.9. geojson serialisation will not work with versions >= 1.10

For more information on this file, see
https://docs.djangoproject.com/en/dev/topics/settings/

For the full list of settings and their values, see
https://docs.djangoproject.com/en/dev/ref/settings/
"""

import os
import pghm

# Build paths inside the project like this: os.path.join(BASE_DIR, ...)
BASE_DIR = os.path.dirname(os.path.dirname(os.path.abspath(__file__)))
# This is application folder
APP_DIR = os.path.dirname(pghm.__file__)


# Quick-start development settings - unsuitable for production
# See https://docs.djangoproject.com/en/dev/howto/deployment/checklist/

# SECURITY WARNING: keep the secret key used in production secret!
SECRET_KEY = 'w2oq7(mg#0@=$1bwplqsqd(3s&yziioq=($1*q2b1l^p(j*ya4'

# SECURITY WARNING: don't run with debug turned on in production!
DEBUG = True

ALLOWED_HOSTS = ["127.0.0.1"]


# Application definition

INSTALLED_APPS = [
    'django.contrib.admin',
    'django.contrib.auth',
    'django.contrib.contenttypes',
    'django.contrib.sessions',
    'django.contrib.messages',
    'django.contrib.staticfiles',
]

INSTALLED_APPS += [
    'django.contrib.gis',
    'leaflet',
    'djgeojson',
    'pghm',
]

MIDDLEWARE_CLASSES = [
    'django.middleware.security.SecurityMiddleware',
    'django.contrib.sessions.middleware.SessionMiddleware',
    'django.middleware.common.CommonMiddleware',
    'django.middleware.csrf.CsrfViewMiddleware',
    'django.contrib.auth.middleware.AuthenticationMiddleware',
    'django.contrib.messages.middleware.MessageMiddleware',
    'django.middleware.clickjacking.XFrameOptionsMiddleware',
]

SERIALIZATION_MODULES = {
    'geojson': 'djgeojson.serializers'
}

ROOT_URLCONF = 'choucas.urls'

TEMPLATES = [
    {
        'BACKEND': 'django.template.backends.django.DjangoTemplates',
        'DIRS': [],
        'APP_DIRS': True,
        'OPTIONS': {
            'context_processors': [
                'django.template.context_processors.debug',
                'django.template.context_processors.request',
                'django.contrib.auth.context_processors.auth',
                'django.contrib.messages.context_processors.messages',
                'django_settings_export.settings_export',
            ],
        },
    },
]


WSGI_APPLICATION = 'choucas.wsgi.application'


# Database
# https://docs.djangoproject.com/en/dev/ref/settings/#databases

# if using SQLite db
SPATIALITE_LIBRARY_PATH = 'mod_spatialite'

#DATABASE_ROUTERS = ['pghm.routers.DataRoute', 'pghm.routers.UsersRoute']

DATABASES = {
    # 'default': {},
    'default': {
        #'ENGINE': 'django.db.backends.postgresql',
        #'ENGINE': 'django.db.backends.postgresql_psycopg2',
        'ENGINE': 'django.contrib.gis.db.backends.postgis',
        'NAME': 'choucas',
        'USER': 'postgres',
        'PASSWORD': 'postgres',
        'HOST': '127.0.0.1',   # https://docs.djangoproject.com/en/dev/ref/settings/#host
        #'HOST': '',             # defined by UNIX domain sockets (‘local’ lines in pg_hba.conf)
        'PORT': '5432',             # can be empty so the default postgresql port is used (5432)
    },

}

# Password validation
# https://docs.djangoproject.com/en/dev/ref/settings/#auth-password-validators

AUTH_PASSWORD_VALIDATORS = [
    {
        'NAME': 'django.contrib.auth.password_validation.UserAttributeSimilarityValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.MinimumLengthValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.CommonPasswordValidator',
    },
    {
        'NAME': 'django.contrib.auth.password_validation.NumericPasswordValidator',
    },
]


# Internationalization
# https://docs.djangoproject.com/en/dev/topics/i18n/

LANGUAGE_CODE = 'en-us'

#TIME_ZONE = 'UTC'
TIME_ZONE = 'Europe/Paris'

USE_I18N = True

USE_L10N = True

USE_TZ = True


# Static files (CSS, JavaScript, Images)
# https://docs.djangoproject.com/en/dev/howto/static-files/

STATIC_URL = '/static/'

# Project particular settings

IGN_KEY = '2pkukowxt0podbngs5sckjry'

IGN_LAYER = [
    'GEOGRAPHICALGRIDSYSTEMS.MAPS',
    'ORTHOIMAGERY.ORTHOPHOTOS',
]

# IGN wmts
IGN_SERVICE = '&service=WMTS&request=GetTile&version=1.0.0&style=normal&tilematrixset=PM&format=image/jpeg&tilematrix={z}&tilerow={y}&tilecol={x}'
SCAN_IGN = 'http://wxs.ign.fr/'+IGN_KEY+'/geoportail/wmts?layer='+IGN_LAYER[0]+IGN_SERVICE
ORTHO_IGN = 'http://wxs.ign.fr/'+IGN_KEY+'/geoportail/wmts?layer='+IGN_LAYER[1]+IGN_SERVICE
BASE_OSM = 'http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png'

# Map attributions //IGN, OSM, PGHM
#GEOPORTAIL_ATTRIB = '<a href="http://www.geoportail.fr/" target="_blank">'+'<img src="http://api.ign.fr/geoportail/api/js/latest/'+'theme/geoportal/img/logo_gp.gif"></a>'
IGN_ATTRIB = '<a href="http://www.ign.fr/" target="_blank">'+'<img style="height: 25px; width: 25px;" title="Institut national de l\'information géographique et forestière" src="http://wxs.ign.fr/static/logos/IGN/IGN.gif"></a>'
OSM_ATTRIB = '©'+'<a href="http://www.openstreetmap.org/copyright" target="_blank"> OpenStreetMap</a>'+' contributors'
IGN_ATTRIB = 'Choucas | '+IGN_ATTRIB
OSM_ATTRIB = OSM_ATTRIB+' | Choucas'

# Export to templates
SETTINGS_EXPORT = [
    'SCAN_IGN',
    'ORTHO_IGN',
    'BASE_OSM',
    'IGN_ATTRIB',
    'OSM_ATTRIB',
]

LEAFLET_CONFIG = {
    'DEFAULT_CENTER': (45.188416, 5.92585),
    'TILES': [
    #    ('IGN Maps', SET_IGN[0], IGN_ATTRIB),
    #    ('IGN Ortho', SET_IGN[1], IGN_ATTRIB),
    #    ('OSM', 'http://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', '(c) OpenStreetMap Contributors'),
    ],
    #'TILES': [],
    'OVERLAYS': [
    #   ('Coeur de parc', 'http://{s}.tilestream.makina-corpus.net/v2/coeur-ecrins/{z}/{x}/{y}.png', 'Ecrins'),
    ],
    'DEFAULT_ZOOM': 10,
    'MIN_ZOOM': 4,
    #'MINIMAP': False,
    'MAX_ZOOM': 17,
    'ATTRIBUTION_PREFIX': 'Powered by django-leaflet',
    'SCALE': 'both',
    'RESET_VIEW': True,
    'PLUGINS': {
        'styledLayer': {
            'css': [ 'Leaflet.StyledLayerControl/css/styledLayerControl.css'],
            'js': [ 'Leaflet.StyledLayerControl/src/styledLayerControl.js'],
            'auto-include': True
        },
        'coordinates': {
            'css': ['Leaflet.Coordinates/dist/Leaflet.Coordinates-0.1.4.css'],
            'js': ['Leaflet.Coordinates/dist/Leaflet.Coordinates-0.1.4.src.js'],
            'auto-include': True
        },
        'sidebar': {
            'css': ['sidebar/leaflet-sidebar.min.css'],
            'js': ['sidebar/leaflet-sidebar.min.js'],
            'auto-include': True
        },
        'ajax': {
            'js': ['leaflet.ajax/leaflet.ajax.min.js'],
            'auto-include': True
        }
        # 'opacity': {
        #     'css': ['Leaflet.OpacityControls/lib/opacity/Control.Opacity.css', 'Leaflet.OpacityControls/lib/jquery/jquery-ui-1.10.3.custom.min.css'],
        #     'js': ['Leaflet.OpacityControls/lib/opacity/Control.Opacity.js', 'Leaflet.OpacityControls/lib/jquery/jquery-ui-1.10.3.custom.min.js', 'Leaflet.OpacityControls/lib/jquery/jquery-1.9.1.js'],
        #     'auto-include': True
        # }
     }
}

# Login url config
LOGIN_REDIRECT_URL = '/'
LOGIN_URL='/login/'
